from _typeshed import Incomplete
from collections.abc import Iterable
from homeassistant.const import EVENT_CORE_CONFIG_UPDATE as EVENT_CORE_CONFIG_UPDATE, STATE_UNAVAILABLE as STATE_UNAVAILABLE, STATE_UNKNOWN as STATE_UNKNOWN
from homeassistant.core import Event as Event, HomeAssistant as HomeAssistant, callback as callback
from homeassistant.loader import Integration as Integration, async_get_config_flows as async_get_config_flows, async_get_integrations as async_get_integrations, bind_hass as bind_hass
from homeassistant.util.json import load_json as load_json
from typing import Any

_LOGGER: Incomplete
TRANSLATION_FLATTEN_CACHE: str
LOCALE_EN: str

def recursive_flatten(prefix: Any, data: dict[str, Any]) -> dict[str, Any]: ...
def component_translation_path(component: str, language: str, integration: Integration) -> str | None: ...
def _load_translations_files_by_language(translation_files: dict[str, dict[str, str]]) -> dict[str, dict[str, Any]]: ...
def _merge_resources(translation_strings: dict[str, dict[str, Any]], components: set[str], category: str) -> dict[str, dict[str, Any]]: ...
def build_resources(translation_strings: dict[str, dict[str, dict[str, Any] | str]], components: set[str], category: str) -> dict[str, dict[str, Any] | str]: ...
async def _async_get_component_strings(hass: HomeAssistant, languages: Iterable[str], components: set[str], integrations: dict[str, Integration]) -> dict[str, dict[str, Any]]: ...

class _TranslationCache:
    __slots__: Incomplete
    hass: Incomplete
    loaded: Incomplete
    cache: Incomplete
    lock: Incomplete
    def __init__(self, hass: HomeAssistant) -> None: ...
    def async_is_loaded(self, language: str, components: set[str]) -> bool: ...
    async def async_load(self, language: str, components: set[str]) -> None: ...
    async def async_fetch(self, language: str, category: str, components: set[str]) -> dict[str, str]: ...
    def get_cached(self, language: str, category: str, components: set[str]) -> dict[str, str]: ...
    async def _async_load(self, language: str, components: set[str]) -> None: ...
    def _validate_placeholders(self, language: str, updated_resources: dict[str, Any], cached_resources: dict[str, Any] | None = None) -> dict[str, Any]: ...
    def _build_category_cache(self, language: str, components: set[str], translation_strings: dict[str, dict[str, Any]]) -> None: ...

async def async_get_translations(hass: HomeAssistant, language: str, category: str, integrations: Iterable[str] | None = None, config_flow: bool | None = None) -> dict[str, str]: ...
def async_get_cached_translations(hass: HomeAssistant, language: str, category: str, integration: str | None = None) -> dict[str, str]: ...
def _async_get_translations_cache(hass: HomeAssistant) -> _TranslationCache: ...

_DIRECT_MAPPED_CATEGORIES: Incomplete

def _async_get_components(hass: HomeAssistant, category: str) -> set[str]: ...
def async_setup(hass: HomeAssistant) -> None: ...
async def async_load_integrations(hass: HomeAssistant, integrations: set[str]) -> None: ...
def async_translations_loaded(hass: HomeAssistant, components: set[str]) -> bool: ...
def async_translate_state(hass: HomeAssistant, state: str, domain: str, platform: str | None, translation_key: str | None, device_class: str | None) -> str: ...
